(*$B- AUFGABE 2.25 *)
PROGRAM zwerge;
CONST nn = 20;
TYPE vektor = ARRAY[1..nn] OF real;
     matrix = ARRAY[1..nn] OF vektor;
VAR n,k,i:integer; a,t : matrix; b,x:vektor;

PROCEDURE tk(k:integer; VAR t: matrix);
VAR i,j :integer;
BEGIN
   FOR i:=1 TO n DO FOR j := 1 TO n DO
   IF i=j THEN t[i,j]:=1 ELSE t[i,j] := 0;
   FOR i:=1 TO n DO t[i,k] := 1/n
END;

PROCEDURE matmult(a,b:matrix; VAR c:matrix);
VAR i,j,k : integer; s: real;
BEGIN
  FOR i:=1 TO n DO FOR j := 1 TO n DO
  BEGIN
    s := 0 ;
    FOR k := 1 TO n DO s := s + a[i,k]*b[k,j];
    c[i,j] :=s
  END
END;

PROCEDURE rueckwaertseinsetzen;
VAR s:real; i,j : integer;
BEGIN
 FOR i := n DOWNTO 1 DO
 BEGIN
  s := b[i];
  FOR j:=i+1 TO n DO s:=s-a[i,j]*x[j];
  x[i]:=s/a[i,i]
 END
END;

PROCEDURE givenselimination;
(* leicht abgeaenderter Algorithmus 5.6, vgl. auch Aufgabe 5.12 *)
VAR i,j,k: integer; cot,co,si,h: real;
BEGIN
 FOR i:=1 TO n DO
 BEGIN
  FOR k := i+1 TO n+1 DO       (* n+1 Gleichungen ! *)
   IF a[k,i]<>0 THEN
   BEGIN
     cot:=a[i,i]/a[k,i];
     si:=1/sqrt(1+cot*cot); co:=si*cot;
     a[i,i]:=a[i,i]*co+a[k,i]*si;
     FOR j:=i+1 TO n DO
     BEGIN
       h:=a[i,j]*co+a[k,j]*si;
       a[k,j]:=-a[i,j]*si+a[k,j]*co;
       a[i,j]:=h
     END;
     h:=b[i]*co+b[k]*si;
     b[k]:=-b[i]*si+b[k]*co;
     b[i]:=h
   END
  END
END;


PROCEDURE mult(a:matrix; x:vektor; VAR y:vektor);
VAR i,j: integer; s:real;
BEGIN
  FOR i := 1 TO n DO
  BEGIN s:=0;
    FOR j := 1 TO n DO s := s + a[i,j]*x[j];
    y[i] := s
  END;
END;

BEGIN
  writeln('Anzahl Zwerge n=?'); read(n);
  tk(1,a);
  FOR k:=2 TO n DO
  BEGIN  tk(k,t); matmult(t,a,a)  END;

  FOR i:= 1 TO n DO
  BEGIN
    a[i,i] := a[i,i]-1;  (* A-I berechnen *)
    a[n+1,i] := 1;       (* letzte Gleichung *)
    b[i] :=0             (* rechte Seite *)
  END;
  b[n+1]:=3;             (* Gesamtmilchmenge *)

 givenselimination; rueckwaertseinsetzen;
 writeln('Loesung');
 FOR i:=1 TO n DO writeln(x[i]);
 writeln('Kontrolle');
 FOR i:=1 TO n DO
 BEGIN tk(i,t); mult(t,x,x) END;
 FOR i:= 1 TO n DO writeln(x[i]);
END.

